





cbuffer	PerFrameCB : register( b0 )
{
	
	matrix		g_matViewProj;
	float		g_rTessellationFactor;

};



struct InputVS
{

	float3	pos		:	POSITION;
};


struct OutputVS
{

	float3	pos		:	POSITION;
};




OutputVS MainVS( InputVS i )
{
	
	OutputVS o;
	o.pos = i.pos;
	return o;
}





struct OutputConstantHS
{

	float	edges[ 3 ]		:	SV_TessFactor;
	float	inside			:	SV_InsideTessFactor;
	
};


struct OutputHS
{
	float3	pos			:	POSITION;
};



OutputConstantHS MainConstantHS( InputPatch< OutputVS, 3 > InPatches, 
				 uint uPatchID : SV_PrimitiveID )
{

	
	OutputConstantHS o;
	o.edges[ 0 ] = o.edges[ 1 ] = o.edges[ 2 ] = g_rTessellationFactor;
	o.inside = g_rTessellationFactor;

	return o;

}



[ domain( "tri" ) ]
[ partitioning( "integer" ) ]
[ outputtopology( "triangle_cw" ) ]
[ outputcontrolpoints( 3 ) ]
[ patchconstantfunc( "MainConstantHS" ) ]

OutputHS MainHS( InputPatch< OutputVS, 3 > InPatches,
		 uint uControlPointID : SV_OutputControlPointID,
		 uint uPatchID : SV_PrimitiveID )
{

	OutputHS o;
	o.pos = InPatches[ uControlPointID ].pos;
	return o;
}



struct OutputDS
{

	float4	pos	:	SV_POSITION;
};


[ domain( "tri" ) ]
OutputDS MainDS( OutputConstantHS i,
		 float3 BaryCentricCoord : SV_DomainLocation,
		 const OutputPatch< OutputHS, 3 > Patches )
{

	OutputDS o;
	float3 p =   BaryCentricCoord.x * Patches[ 0 ].pos 
		   + BaryCentricCoord.y * Patches[ 1 ].pos
		   + BaryCentricCoord.z * Patches[ 2 ].pos;

	o.pos = mul( float4( p, 1 ), g_matViewProj );

	return o;

}


float4 MainWirePS( OutputDS In ) : SV_TARGET
{

	return float4( 1, 0, 0, 1 );
}


float4 MainSolidPS( OutputDS In ) : SV_TARGET
{

	return float4( 1, 1, 1, 1 );

}







