// TessellationSample.cpp :  α׷   մϴ.
//

#include "stdafx.h"
#include "TessellationSample.h"

#define MAX_LOADSTRING 100

//  :
HINSTANCE hInst;								//  νϽԴϴ.
TCHAR szTitle[MAX_LOADSTRING];					//  ǥ ؽƮԴϴ.
TCHAR szWindowClass[MAX_LOADSTRING];			// ⺻ â Ŭ ̸Դϴ.

//  ڵ ⿡  ִ Լ  Դϴ.
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);




struct SimpleVertex
{

	XMFLOAT3		Pos;

};
SimpleVertex					g_vxVertexArray[ 3 ];



HWND							g_hWnd = 0;
ID3D11Device*					g_ipDevice = nullptr;
ID3D11DeviceContext*			g_ipImmediateContext = nullptr;
IDXGISwapChain*					g_ipSwapChain = nullptr;

ID3D11RenderTargetView*			g_ipRTV = nullptr;
ID3D11DepthStencilView*			g_ipDSV = nullptr;

ID3D11VertexShader*				g_ipVS = nullptr;
ID3D11HullShader*				g_ipHS = nullptr;
ID3D11DomainShader*				g_ipDS = nullptr;
ID3D11PixelShader*				g_ipSolidPS = nullptr;
ID3D11PixelShader*				g_ipWirePS = nullptr;

ID3D11InputLayout*				g_ipILO = nullptr;
ID3D11Buffer*					g_ipVB = nullptr;

ID3D11RasterizerState*			g_ipSolidRasterizerState = nullptr;
ID3D11RasterizerState*			g_ipWireFrameRasterizerState = nullptr;


struct PerFrameCB
{

	XMMATRIX	matViewProj;
	float		rTessellationFactor;
};

ID3D11Buffer*					g_ipPerFrameBuffer = nullptr;
UINT							g_uPerFrameBufferBindIndex = 0;

float							g_rSubDivisionLevel = 1.0f;

XMMATRIX						g_matWorld;
XMMATRIX						g_matView;
XMMATRIX						g_matProj;




BOOL							g_bIsDrawWireFrame = FALSE;


HRESULT CompileShaderFromFile( WCHAR* pFileName, 
							   LPCSTR szEntryName,
							   LPCSTR szShaderModel,
							   ID3DBlob** ipResult )
{

	HRESULT hr = S_OK;	
	DWORD dwShaderFlag = D3DCOMPILE_ENABLE_STRICTNESS;;

#ifdef _DEBUG	
	dwShaderFlag |= D3DCOMPILE_DEBUG;;
#endif

	ID3DBlob* ipErrorBlob;
	hr = ::D3DX11CompileFromFile( pFileName, 
							      NULL, 
								  NULL, 
								  szEntryName, 
								  szShaderModel, 
								  dwShaderFlag, 
								  0, 
								  NULL, 
								  ipResult, 
								  &ipErrorBlob, 
								  NULL );
	if( hr != S_OK )
	{
		if( ipErrorBlob != 0x00 )
		{
			::OutputDebugStringA( (char*)ipErrorBlob->GetBufferPointer() );
		}
		SAFE_RELEASE( ipErrorBlob );
		return hr;
	}

	SAFE_RELEASE( ipErrorBlob );

	return S_OK;

}








void InitD3D( HWND hWnd )
{


	RECT rc;
	::GetClientRect( hWnd, &rc );
	UINT uWidth = rc.right - rc.left;
	UINT uHeight = rc.bottom - rc.top;	
	UINT uCreateDeviceFlags = 0;

#ifdef _DEBUG
	uCreateDeviceFlags |= D3D11_CREATE_DEVICE_DEBUG;
#endif


	D3D_DRIVER_TYPE dxDriverTypeArray[] = 
	{
		D3D_DRIVER_TYPE_HARDWARE,
		D3D_DRIVER_TYPE_WARP,
		D3D_DRIVER_TYPE_REFERENCE,
	};
	UINT uDriverTypeCount = ARRAYSIZE( dxDriverTypeArray );

	D3D_FEATURE_LEVEL dxFeatureLevelArray[] = 
	{
		D3D_FEATURE_LEVEL_11_0,
		D3D_FEATURE_LEVEL_10_1,
		D3D_FEATURE_LEVEL_10_0,
		D3D_FEATURE_LEVEL_9_3,
		D3D_FEATURE_LEVEL_9_2,
		D3D_FEATURE_LEVEL_9_1,
	};
	UINT uFeatureLevelCount = ARRAYSIZE( dxFeatureLevelArray );



	HRESULT hr = E_FAIL;

	DXGI_SWAP_CHAIN_DESC	dxSwapChainDesc;
	::memset( &dxSwapChainDesc, 0, sizeof( DXGI_SWAP_CHAIN_DESC ) );

	dxSwapChainDesc.BufferCount = 1;	
	dxSwapChainDesc.BufferUsage = DXGI_USAGE_RENDER_TARGET_OUTPUT;
	dxSwapChainDesc.Flags = DXGI_SWAP_CHAIN_FLAG_ALLOW_MODE_SWITCH;
	dxSwapChainDesc.SwapEffect = DXGI_SWAP_EFFECT_DISCARD;
	dxSwapChainDesc.OutputWindow = hWnd;
	dxSwapChainDesc.Windowed = TRUE;

	dxSwapChainDesc.BufferDesc.Width = uWidth;
	dxSwapChainDesc.BufferDesc.Height = uHeight;
	dxSwapChainDesc.BufferDesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
	dxSwapChainDesc.BufferDesc.RefreshRate.Numerator = 60;
	dxSwapChainDesc.BufferDesc.RefreshRate.Denominator = 1;

	dxSwapChainDesc.SampleDesc.Count = 1;
	dxSwapChainDesc.SampleDesc.Quality = 0;


	D3D_FEATURE_LEVEL dxResultFeatureLevel = D3D_FEATURE_LEVEL_11_0;

	for( UINT u = 0;		u < uDriverTypeCount;		++u )
	{

		D3D_DRIVER_TYPE dxCurrent = dxDriverTypeArray[ u ];

		

		hr = ::D3D11CreateDeviceAndSwapChain( NULL, 
											  dxCurrent, 
											  NULL,
											  uCreateDeviceFlags,
											  dxFeatureLevelArray,
											  uFeatureLevelCount,
											  D3D11_SDK_VERSION,
											  &dxSwapChainDesc,
											  &::g_ipSwapChain,
											  &::g_ipDevice,
											  &dxResultFeatureLevel,
											  &::g_ipImmediateContext );

		if( dxResultFeatureLevel != D3D_FEATURE_LEVEL_11_0 )
		{
			dxCurrent = D3D_DRIVER_TYPE_REFERENCE;
			continue;
		}

		if( hr == S_OK )
		{
			break;
		}

	}

	assert( hr == S_OK );


	ID3D11Texture2D* ipBackBuffer = nullptr;
	hr = ::g_ipSwapChain->GetBuffer( 0, __uuidof( ID3D11Texture2D ), (LPVOID*)&ipBackBuffer );
	assert( hr == S_OK );
	
	hr = ::g_ipDevice->CreateRenderTargetView( ipBackBuffer, NULL, &::g_ipRTV );
	assert( hr == S_OK );



	D3D11_TEXTURE2D_DESC dxDepthStencilDesc;
	::memset( &dxDepthStencilDesc, 0, sizeof( D3D11_TEXTURE2D_DESC ) );
	dxDepthStencilDesc.Width = uWidth;
	dxDepthStencilDesc.Height = uHeight;
	dxDepthStencilDesc.MipLevels = 1;
	dxDepthStencilDesc.ArraySize = 1;
	dxDepthStencilDesc.Format = DXGI_FORMAT_D24_UNORM_S8_UINT;
	dxDepthStencilDesc.Usage = D3D11_USAGE_DEFAULT;
	dxDepthStencilDesc.BindFlags = D3D11_BIND_DEPTH_STENCIL;
	dxDepthStencilDesc.CPUAccessFlags = 0;
	dxDepthStencilDesc.MiscFlags = 0;
	dxDepthStencilDesc.SampleDesc.Count = 1;
	dxDepthStencilDesc.SampleDesc.Quality = 0;
	

	ID3D11Texture2D* ipDepthStencilTex = nullptr;
	hr = ::g_ipDevice->CreateTexture2D( &dxDepthStencilDesc, NULL, &ipDepthStencilTex );
	assert( hr == S_OK );

	D3D11_DEPTH_STENCIL_VIEW_DESC dxDepthStencilViewDesc;
	::memset( &dxDepthStencilViewDesc, 0, sizeof( D3D11_DEPTH_STENCIL_VIEW_DESC ) );
	dxDepthStencilViewDesc.Format = dxDepthStencilDesc.Format;
	dxDepthStencilViewDesc.ViewDimension = D3D11_DSV_DIMENSION_TEXTURE2D;
	dxDepthStencilViewDesc.Texture2D.MipSlice = 0;
	hr = ::g_ipDevice->CreateDepthStencilView( ipDepthStencilTex, &dxDepthStencilViewDesc, &::g_ipDSV );
	assert( hr == S_OK );



	::g_ipImmediateContext->OMSetRenderTargets( 1, &::g_ipRTV, ::g_ipDSV );


	D3D11_VIEWPORT vp;
	vp.Width = static_cast< FLOAT >( uWidth );
	vp.Height = static_cast< FLOAT >( uHeight );
	vp.MinDepth = 0.0f;
	vp.MaxDepth = 1.0f;
	vp.TopLeftX = 0;
	vp.TopLeftY = 0;
	::g_ipImmediateContext->RSSetViewports( 1, &vp );


	ID3DBlob* ipBlobVS = nullptr;
	ID3DBlob* ipBlobHS = nullptr;
	ID3DBlob* ipBlobDS = nullptr;
	ID3DBlob* ipBlobWirePS = nullptr;
	ID3DBlob* ipBlobSolidPS = nullptr;


	hr = ::CompileShaderFromFile( L"SimpleTessellation.hlsl", 
								  "MainVS",
								  "vs_5_0",
								  &ipBlobVS );
	assert( hr == S_OK );


	hr = ::CompileShaderFromFile( L"SimpleTessellation.hlsl", 
								  "MainHS",
								  "hs_5_0",
								  &ipBlobHS );
	assert( hr == S_OK );

	hr = ::CompileShaderFromFile( L"SimpleTessellation.hlsl", 
								  "MainDS",
								  "ds_5_0",
								  &ipBlobDS );
	assert( hr == S_OK );


	hr = ::CompileShaderFromFile( L"SimpleTessellation.hlsl", 
								  "MainWirePS",
								  "ps_5_0",
								  &ipBlobWirePS );
	assert( hr == S_OK );

	hr = ::CompileShaderFromFile( L"SimpleTessellation.hlsl", 
								  "MainSolidPS",
								  "ps_5_0",
								  &ipBlobSolidPS );
	assert( hr == S_OK );





	hr = ::g_ipDevice->CreateVertexShader( ipBlobVS->GetBufferPointer(), 
										   ipBlobVS->GetBufferSize(), 
										   NULL,
										   &::g_ipVS );
	assert( hr == S_OK );

	hr = ::g_ipDevice->CreateHullShader( ipBlobHS->GetBufferPointer(),
										 ipBlobHS->GetBufferSize(),
										 NULL, 
										 &::g_ipHS );
	assert( hr == S_OK );


	hr = ::g_ipDevice->CreateDomainShader( ipBlobDS->GetBufferPointer(),
										   ipBlobDS->GetBufferSize(),
										   NULL,
										   &::g_ipDS );
	assert( hr == S_OK );


	hr = ::g_ipDevice->CreatePixelShader( ipBlobWirePS->GetBufferPointer(),
										  ipBlobWirePS->GetBufferSize(),
										  NULL,
										  &::g_ipWirePS );
	assert( hr == S_OK );


	hr = ::g_ipDevice->CreatePixelShader( ipBlobSolidPS->GetBufferPointer(),
										  ipBlobSolidPS->GetBufferSize(),
										  NULL,
										  &::g_ipSolidPS );
	assert( hr == S_OK );


	D3D11_INPUT_ELEMENT_DESC	layout[] = 
	{
		{ "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D11_INPUT_PER_VERTEX_DATA, 0 },
	};

	hr = ::g_ipDevice->CreateInputLayout( layout, ARRAYSIZE( layout ), ipBlobVS->GetBufferPointer(), ipBlobVS->GetBufferSize(), &::g_ipILO );
	assert( hr == S_OK );


	SAFE_RELEASE( ipBlobVS );
	SAFE_RELEASE( ipBlobHS );
	SAFE_RELEASE( ipBlobDS );
	SAFE_RELEASE( ipBlobWirePS );
	SAFE_RELEASE( ipBlobSolidPS );




	D3D11_BUFFER_DESC	dxBufDesc;
	::memset( &dxBufDesc, 0, sizeof( D3D11_BUFFER_DESC ) );
	dxBufDesc.Usage = D3D11_USAGE_DYNAMIC;
	dxBufDesc.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
	dxBufDesc.CPUAccessFlags = D3D11_CPU_ACCESS_WRITE;
	dxBufDesc.MiscFlags = 0;
	dxBufDesc.ByteWidth = sizeof( PerFrameCB );
	hr = ::g_ipDevice->CreateBuffer( &dxBufDesc, NULL, &::g_ipPerFrameBuffer );
	assert( hr == S_OK );



	D3D11_RASTERIZER_DESC dxRasterDesc;
	::memset( &dxRasterDesc, 0, sizeof( D3D11_RASTERIZER_DESC ) );
	dxRasterDesc.FillMode = D3D11_FILL_SOLID;
	dxRasterDesc.CullMode = D3D11_CULL_NONE;
	dxRasterDesc.DepthClipEnable = TRUE;
	hr = ::g_ipDevice->CreateRasterizerState( &dxRasterDesc, &::g_ipSolidRasterizerState );
	assert( hr == S_OK );


	dxRasterDesc.FillMode = D3D11_FILL_WIREFRAME;
	hr = ::g_ipDevice->CreateRasterizerState( &dxRasterDesc, &::g_ipWireFrameRasterizerState );
	assert( hr == S_OK );



	::g_vxVertexArray[ 0 ].Pos = ::XMFLOAT3( 0.0f, 0.0f, 0.0f );
	::g_vxVertexArray[ 1 ].Pos = ::XMFLOAT3( -10.0f, 0.0f, 10.0f );
	::g_vxVertexArray[ 2 ].Pos = ::XMFLOAT3( 10.0f, 0.0f, 10.0f );	

	D3D11_BUFFER_DESC dxVertexBufDesc;
	::memset( &dxVertexBufDesc, 0, sizeof( D3D11_BUFFER_DESC ) );
	dxVertexBufDesc.ByteWidth = sizeof( SimpleVertex ) * ARRAYSIZE( ::g_vxVertexArray );
	dxVertexBufDesc.Usage = D3D11_USAGE_DEFAULT;
	dxVertexBufDesc.BindFlags = D3D11_BIND_VERTEX_BUFFER;

	D3D11_SUBRESOURCE_DATA dxVertexBufInitData;
	::memset( &dxVertexBufInitData, 0, sizeof( D3D11_SUBRESOURCE_DATA ) );
	dxVertexBufInitData.pSysMem = ::g_vxVertexArray;
	hr = ::g_ipDevice->CreateBuffer( &dxVertexBufDesc, &dxVertexBufInitData, &::g_ipVB );
	assert( hr == S_OK );
	


	::g_matWorld = ::XMMatrixIdentity();

	XMVECTOR vecEye = XMVectorSet( 0.0f, 5.0f, -5.0f, 0.0f );
	XMVECTOR vecAt = XMVectorSet( 0.0f, 0.0f, 0.0f, 0.0f );
	XMVECTOR vecUp = XMVectorSet( 0.0f, 1.0f, 0.0f, 0.0f );
	::g_matView = XMMatrixLookAtLH( vecEye, vecAt, vecUp );

	::g_matProj = XMMatrixPerspectiveFovLH( XM_PIDIV2, 1.3333f, 0.01f, 1000.0f );

	
}


void Render( void )
{

	float ClearColor[ 4 ] = { 0.0f, 0.0f, 0.0f, 1.0f };
	::g_ipImmediateContext->ClearRenderTargetView( ::g_ipRTV, ClearColor );
	::g_ipImmediateContext->ClearDepthStencilView( ::g_ipDSV, D3D11_CLEAR_DEPTH, 1.0f, 0 );



	XMMATRIX matViewProjT = ::XMMatrixMultiply( ::g_matView, ::g_matProj );
	matViewProjT = ::XMMatrixTranspose( matViewProjT );
	
	D3D11_MAPPED_SUBRESOURCE dxMappedResource;
	::g_ipImmediateContext->Map( ::g_ipPerFrameBuffer, 0, D3D11_MAP_WRITE_DISCARD, 0, &dxMappedResource );
	PerFrameCB* pDataPtr = ( PerFrameCB* )dxMappedResource.pData;
	pDataPtr->matViewProj = matViewProjT;
	pDataPtr->rTessellationFactor = ::g_rSubDivisionLevel;
	::g_ipImmediateContext->Unmap( ::g_ipPerFrameBuffer, 0 );


	::g_ipImmediateContext->VSSetConstantBuffers( ::g_uPerFrameBufferBindIndex, 1, &::g_ipPerFrameBuffer );
	::g_ipImmediateContext->HSSetConstantBuffers( ::g_uPerFrameBufferBindIndex, 1, &::g_ipPerFrameBuffer );
	::g_ipImmediateContext->DSSetConstantBuffers( ::g_uPerFrameBufferBindIndex, 1, &::g_ipPerFrameBuffer );
	::g_ipImmediateContext->PSSetConstantBuffers( ::g_uPerFrameBufferBindIndex, 1, &::g_ipPerFrameBuffer );

	::g_ipImmediateContext->VSSetShader( ::g_ipVS, NULL, 0 );
	::g_ipImmediateContext->HSSetShader( ::g_ipHS, NULL, 0 );
	::g_ipImmediateContext->DSSetShader( ::g_ipDS, NULL, 0 );
	::g_ipImmediateContext->GSSetShader( NULL, NULL, 0 );


	if( ::g_bIsDrawWireFrame == TRUE )
	{
		::g_ipImmediateContext->RSSetState( ::g_ipWireFrameRasterizerState );
		::g_ipImmediateContext->PSSetShader( ::g_ipWirePS, NULL, 0 );		
	}
	else
	{
		::g_ipImmediateContext->PSSetShader( ::g_ipSolidPS, NULL, 0 );
		::g_ipImmediateContext->RSSetState( ::g_ipSolidRasterizerState );
	}
	


	::g_ipImmediateContext->IASetInputLayout( ::g_ipILO );
	UINT uStride = sizeof( SimpleVertex );
	UINT uOffset = 0;
	::g_ipImmediateContext->IASetVertexBuffers( 0, 1, &::g_ipVB, &uStride, &uOffset );
	::g_ipImmediateContext->IASetPrimitiveTopology( D3D11_PRIMITIVE_TOPOLOGY_3_CONTROL_POINT_PATCHLIST );
	::g_ipImmediateContext->Draw( ARRAYSIZE( ::g_vxVertexArray ), 0 );


	::g_ipSwapChain->Present( 0, 0 );

}

void ClearD3D( void )
{

	if( ::g_ipImmediateContext != nullptr )
	{
		::g_ipImmediateContext->ClearState();
	}



	SAFE_RELEASE( ::g_ipPerFrameBuffer );

	SAFE_RELEASE( ::g_ipVS );
	SAFE_RELEASE( ::g_ipHS );
	SAFE_RELEASE( ::g_ipDS );
	SAFE_RELEASE( ::g_ipSolidPS );
	SAFE_RELEASE( ::g_ipWirePS );

	SAFE_RELEASE( ::g_ipILO );
	SAFE_RELEASE( ::g_ipVB );

	SAFE_RELEASE( ::g_ipSolidRasterizerState );
	SAFE_RELEASE( ::g_ipWireFrameRasterizerState );


	SAFE_RELEASE( ::g_ipDSV );
	SAFE_RELEASE( ::g_ipRTV );

	SAFE_RELEASE( ::g_ipSwapChain );
	SAFE_RELEASE( ::g_ipImmediateContext );
	SAFE_RELEASE( ::g_ipDevice );

}



int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: ⿡ ڵ带 Էմϴ.
	MSG msg = { 0 };
	HACCEL hAccelTable;

	//  ڿ ʱȭմϴ.
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_TESSELLATIONSAMPLE, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	//  α׷ ʱȭ մϴ.
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	::InitD3D( ::g_hWnd );

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_TESSELLATIONSAMPLE));

	// ⺻ ޽ Դϴ.
	while ( WM_QUIT != msg.message )
	{

		if( ::PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) )
		{		
			::TranslateMessage(&msg);
			::DispatchMessage(&msg);
		}
		else
		{
			::Render();
		}
		
	}


	::ClearD3D();

	return (int) msg.wParam;
}



//
//  Լ: MyRegisterClass()
//
//  : â Ŭ մϴ.
//
//  :
//
//    Windows 95 ߰ 'RegisterClassEx' Լ 
//    ش ڵ尡 Win32 ý۰ ȣȯǵ
//    Ϸ 쿡  Լ մϴ.  Լ ȣؾ
//    ش  α׷ 
//    'ùٸ '     ֽϴ.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_TESSELLATIONSAMPLE));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_TESSELLATIONSAMPLE);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   Լ: InitInstance(HINSTANCE, int)
//
//   : νϽ ڵ ϰ  â ϴ.
//
//   :
//
//         Լ  νϽ ڵ   ϰ
//         α׷ â   ǥմϴ.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // νϽ ڵ   մϴ.

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   //UpdateWindow(hWnd);

   ::g_hWnd = hWnd;

   return TRUE;
}

//
//  Լ: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  :  â ޽ óմϴ.
//
//  WM_COMMAND	-  α׷ ޴ óմϴ.
//  WM_PAINT	-  â ׸ϴ.
//  WM_DESTROY	-  ޽ Խϰ ȯմϴ.
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{


	case WM_KEYDOWN :
		{
			switch( wParam )
			{
			case VK_UP :
				{
					::g_rSubDivisionLevel += 1.0f;
					if( ::g_rSubDivisionLevel > 64.0f )
					{
						::g_rSubDivisionLevel = 64.0f;
					}
				}
				break;

			case VK_DOWN :
				{
					if( ::g_rSubDivisionLevel > 0 )
					{
						::g_rSubDivisionLevel -= 1.0f;
					}
				}
				break;


			

			}

	
		}

		break;



	case WM_CHAR :
		{

			if( wParam == 'w' )
			{
				::g_bIsDrawWireFrame = !::g_bIsDrawWireFrame;
			}

		}
		break;


	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// ޴   мմϴ.
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: ⿡ ׸ ڵ带 ߰մϴ.
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

//  ȭ  ޽ óԴϴ.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
